/*******************************************************************************
* Copyright (c)                                                                *
*           2005   Tristan Allwood,                                            *
*           2005   Daniel Burke,                                               *
*           2005   Marc Hull,                                                  *
*           2005   Ekaterina Itskova,                                          *
*           2005   Steve Zymler                                                *
*                                                                              *
* Permission is hereby granted, free of charge, to any person obtaining a      *
* copy of this software and associated documentation files (the                *
* "Software"), to deal in the Software without restriction, including          *
* without limitation the rights to use, copy, modify, merge, publish,          *
* distribute, sublicense, and/or sell copies of the Software, and to           *
* permit persons to whom the Software is furnished to do so, subject to        *
* the following conditions:                                                    *
*                                                                              *
* The above copyright notice and this permission notice shall be included      *
* in all copies or substantial portions of the Software.                       *
*                                                                              *
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS      *
* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF                   *
* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.       *
* IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY         *
* CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,         *
* TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE            *
* SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                       *
*******************************************************************************/
/*
 * Created on 20.10.2004
 *
 */
package uk.ac.ic.doc.kevlar.gui.internal.taskpane.directorypane;

import java.io.FileNotFoundException;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Rectangle;

import uk.ac.ic.doc.kevlar.gui.internal.caches.ColorCache;
import uk.ac.ic.doc.kevlar.gui.internal.caches.FontCache;
import uk.ac.ic.doc.kevlar.gui.internal.caches.ImageCache;
import uk.ac.ic.doc.kevlar.gui.internal.taskpane.ATaskPane;

/**
 * @author ei02
 *
 */

public class FileEntry extends ADirectoryTreeNodeEntry {
	
	static final String PROGRAM_BACKGROUND_FILENAME = "file.png";
	static final String PROGRAM_ROLLOVER_FILENAME = "file_rollover.png";
	
	public FileEntry(){}
	
	public FileEntry(IFileNode program, int panePositionIndex, ATaskPane programPane, int animationMode) {
	    
		super(program, panePositionIndex, programPane, animationMode);
		
		initialise();
				
	}
	
	private void initialise()
	{
		try {
			
			this.background = ImageCache.get(PROGRAM_BACKGROUND_FILENAME);
			
		} catch (FileNotFoundException e) {
			
			this.background = null;
			
		}
				
		try {
			
			this.rollover = ImageCache.get(PROGRAM_ROLLOVER_FILENAME);
			
		} catch (FileNotFoundException e) {
			
			this.rollover = null;
			
		}
	}
	
	public void drawBefore(GC gc, Rectangle area)
	{
	    gc.setForeground(ColorCache.get(0, 0, 0));
	    gc.setFont(FontCache.get("Arial", 8, SWT.NORMAL));
		super.drawBefore(gc, area);
				
	}
	
/*	public void mousePress(Point position, int mouseButton)
	{
	    super.mousePress(position, mouseButton);
	    
		boolean isDisplayed = HelpManager.getSingleton().isDisplayed();
		
		if (mouseButton==1 && !isDisplayed)
		{
			if (progDesc == null)
			{
				progDesc = getProgramDescription();
			}
			
			int x = getAbsoluteArea().x - HelpManager.getSingleton().getWidth() - 20;
			HelpManager.getSingleton().displayProgramHelp(progDesc,x, area.y);
		}
	}
	
	
	public void onDrag(Point offset) {
	    
		if (HelpManager.getSingleton().isDisplayed())
		{
			HelpManager.getSingleton().hideHelp();
		}
		Program program = createProgram();
		CanvasManager.getSingleton().setDragObject(program, offset);
		
	} */
	
/*	private IProgramIDDescription getProgramDescription()
	{
		IProgramIDDescription helpDesc = null;
		Set<IProgramIDDescription> desc = GUIManager.getHial().getProgramTreeRoot().getSecond();
		
		Iterator descriptionIterator = desc.iterator();
		
		while(descriptionIterator.hasNext())
		{
			IProgramIDDescription description = (IProgramIDDescription) descriptionIterator.next();
			if (description.getFriendlyName().equals(dataNode.getName()))
			{
				helpDesc = description;
			}
		}
		
		return helpDesc;
		
	} 
	
	Program createProgram()
	{
		Program program = null;
		
		if (progDesc == null)
		{
			program = new Program(((IProgramNode)dataNode).getDescription());
		}
		else
		{
			program = new Program(progDesc);
		}
		return program;
	} */
	
}
